<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class Excel {
    /**
     * +----------------------------------------------------------
     * 导出会员资料
     * +----------------------------------------------------------
     * $module 模块
     * $data 数据源
     * +----------------------------------------------------------
     */
    function export_excel($module, $data = array(), $custom_name = '') {
        set_time_limit(0);
        require (ROOT_PATH . ADMIN_PATH . '/include/phpexcel/PHPExcel.php');

        // 创建一个处理对象实例
        $objExcel = new PHPExcel();
        
        // 创建文件格式写入对象实例, uncomment
        $objWriter = PHPExcel_IOFactory::createWriter($objExcel, 'Excel5');  

        // 设置当前的sheet索引，用于后续的内容操作，一般只有在使用多个sheet的时候才需要显示调用，缺省情况下，PHPExcel会自动创建第一个sheet被设置SheetIndex=0 
        $objExcel->setActiveSheetIndex(0);       
        $objActSheet = $objExcel->getActiveSheet();       
    
        // STEP1.设置表格标题文字
        $column = $data['head'] ? count($data['head']) : 25; // 总列数
        $objActSheet->mergeCells('A1' . ':' . $this->number_letter($column) . '1'); // 合并单元格
        if ($custom_name) {
            $objActSheet->setCellValue('A1', $custom_name); // 设置合并后的单元格内容
        } else {
            $objActSheet->setCellValue('A1', $GLOBALS['_CFG']['site_name'] . '-' . $GLOBALS['_LANG'][$module . '_list']); // 设置合并后的单元格内容
        }
        
        // STEP2.设置表格标题栏内容
        foreach ((array)$data['head'] as $key => $value) {
            $objActSheet->getColumnDimension($this->number_letter($key + 1))->setAutoSize(true);
            $objActSheet->setCellValue($this->number_letter($key + 1) . '2', $value);
        }

        // STEP3.列出表格内容
        foreach ((array)$data['list'] as $row_number => $row) {
            foreach ((array)$row as $key => $value) {
                $objActSheet->setCellValue($this->number_letter($key + 1) . ($row_number + 3), $value);
            }
        }
     
        // 文件名
        if ($custom_name) {
            $outputFileName = $custom_name . '.xls';
        } else {
            $outputFileName = strtoupper($module) . '_LIST_' . date('Ymdhi') . '.xls';
        }
     
        // 文件直接输出到浏览器
        header ( 'Pragma:public');
        header ( 'Expires:0');
        header ( 'Cache-Control:must-revalidate,post-check=0,pre-check=0');
        header ( 'Content-Type:application/force-download');
        header ( 'Content-Type:application/vnd.ms-excel');
        header ( 'Content-Type:application/octet-stream');
        header ( 'Content-Type:application/download');
        header ( 'Content-Disposition:attachment;filename='. $outputFileName );
        header ( 'Content-Transfer-Encoding:binary');
        $objWriter->save('php://output');
    }  
 
    /**
     * +----------------------------------------------------------
     * 数据导入
     * +----------------------------------------------------------
     */
    function import_execl($file, $table, $field_name_list, $data = array(), $row_start = 2, $sheet = 0) {
        set_time_limit(0);
        require (ROOT_PATH . ADMIN_PATH . '/include/phpexcel/PHPExcel.php');
     
        //建立reader对象
        $objRead = new PHPExcel_Reader_Excel2007();
        
        // 验证传入的EXCEL文件
        $file_url = $_FILES[$file]["tmp_name"];
        if (empty($file_url) or !file_exists($file_url))  return 'file_not_exists';
        if (!$objRead->canRead($file_url)) {
            $objRead = new PHPExcel_Reader_Excel5();
            if (!$objRead->canRead($file_url)) {
                return 'no_excel';
            }
        }

        $objExcel = $objRead->load($file_url); // 建立excel对象
        $objActSheet = $objExcel->getSheet($sheet); // 获取指定的sheet表
        $highestColumn = $this->number_letter($objActSheet->getHighestColumn(), false); // 取得最大的列号对应的数字
        $highestRow = $objActSheet->getHighestRow(); // 获取总行数

        for ($row_number = $row_start; $row_number <= $highestRow; $row_number++) { // 按行.读取内容
            $field_value_list = '';
            for ($column_number = 1; $column_number <= $highestColumn; $column_number++) { // 按列.读取内容
                $cell_id = $this->number_letter($column_number) . $row_number; // 对应数字和字母转换
                $cell_value = $objActSheet->getCell($cell_id)->getValue();
                //$cell_value = $objActSheet->getCell($cell_id)->getCalculatedValue(); // 获取公式计算的值
                if ($cell_value instanceof PHPExcel_RichText) { // 富文本转换字符串
                    $cell_value = $cell_value->__toString();
                }

                $field_value_list .= "'" . addslashes($cell_value) . "', ";  
            }
            $field_value_list = rtrim($field_value_list, ', ');
            $sql = "INSERT INTO " . $GLOBALS['dou']->table($table) . " (" . $field_name_list . $data['field_name_list'] . ")" . " VALUES (" . $field_value_list . $data['field_value_list'] . ")";
            if (!$GLOBALS['dou']->query($sql)) {
                echo '导入数据库失败：' . $sql;
                exit;
            }
        }
        
        return 'success';
    }

    /**
     * +----------------------------------------------------------
     * 对应数字和字母转换
     * +----------------------------------------------------------
     */
    function number_letter($value, $is_number = true) {
        $box = array(1 => 'A', 2 => 'B', 3 => 'C', 4 => 'D', 5 => 'E', 6 => 'F', 7 => 'G', 8 => 'H', 9 => 'I', 10 => 'J', 11 => 'K', 12 => 'L', 13 => 'M', 14 => 'N', 15 => 'O', 16 => 'P', 17 => 'Q', 18 => 'R', 19 => 'S', 20 => 'T', 21 => 'U', 22 => 'V', 23 => 'W', 24 => 'X', 25 => 'Y', 26 => 'Z');
        
        if ($is_number) {
            return $box[$value];
        } else {
            return array_search($value, $box); // 在数组中搜索键值，并返回它的键名（这里的键名是数字）
        }
    }
 
    /**
     * +----------------------------------------------------------
     * 还原科学计数
     * +----------------------------------------------------------
     */
    function decimal_notation($num) {
        $parts = explode('E', $num);
        if (count($parts) != 2) {
            return $num;
        }
        $exp = abs(end($parts)) + 3;
        $decimal = number_format($num, $exp, '.', '');
        $decimal = rtrim($decimal, '0');

        return rtrim($decimal, '.');
    }
}
?>